import { createStore } from "vuex";
import tableStore from "@/store/tables";
import orderItemStore from "@/store/orderItems";
import { controller_User } from "@/services/openapi";

interface AppStateModel {
  user: controller_User;
  groups: string[];
  version: string;
}
export default createStore({
  state: {
    user: {
      username: "",
      show_cold_drinks: true,
      show_hot_drinks: true,
    },
    groups: [""],
    version: "",
  },
  getters: {
    getUser(state: AppStateModel) {
      return state.user;
    },
    getGroups(state: AppStateModel) {
      return state.groups;
    },
    getUsername(state: AppStateModel) {
      return state.user.username;
    },
    getVersion(state: AppStateModel) {
      return state.version;
    },
  },
  mutations: {
    setUser(state: AppStateModel, _user: controller_User) {
      state.user = _user;
    },
    setGroups(state: AppStateModel, groups: string[]) {
      state.groups = groups;
    },
    setVersion(state: AppStateModel, version: string) {
      state.version = version;
    },
  },
  actions: {},
  modules: {
    tableStore,
    orderItemStore,
  },
});
